% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
%
% boot loader splash code
%
% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


% Boot loader splash areas to uncover.
%
/bsplash.areas [
  [   0   0  639  479 true ]
] def


% start value
/rand.start time def


% Generate pseudo random number.
% Good enough for boot loader splash screen.
%
% ( ) ==> ( int )
%
/rand {
  rand.start 59 mul 97 add 0x7fffffff and
  /rand.start over def
} def

% Show one character with sleep
%
% ( character ) ==> ( )
%
/bcs {
	show 100000 usleep
} def

% Show boot loader splash.
%
% ( ) ==> ( )
%
/bsplash.show {
  1 activateimage loadpalette
  /max_image_colors max_image_colors image.colors max def

  bsplash.areas 0 get
  dup 0 get over 1 get moveto
  dup 2 get over 3 get rot pop currentpoint 4 2 roll image

  currentpoint
  currentcolor
  font1 setfont
  bblack setcolor

  253 400 moveto
  "M" bcs
  "a" bcs
  "d" bcs
  "e" bcs
  " " bcs
  "i" bcs
  "n" bcs
  " " bcs
  "H" bcs
  "u" bcs
  "n" bcs
  "g" bcs
  "a" bcs
  "r" bcs
  "y" bcs

  254 420 moveto
  "w" bcs
  "w" bcs
  "w" bcs
  "." bcs
  "u" bcs
  "h" bcs
  "u" bcs
  "l" bcs
  "i" bcs
  "n" bcs
  "u" bcs
  "x" bcs
  "." bcs
  "h" bcs
  "u" bcs

  font3 setfont
  bred setcolor
  440 110 moveto
  "1" bcs
  "." bcs
  "1" bcs

  setcolor
  moveto

  1000000 usleep

  0 activateimage
} def


% Just wait.
%
% ( ) ==> ( )
%
/bsplash.done {
  1500000 usleep
} def
