% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
% Create new main window.
%
% ( ) ==> ( window )
%
/window.main {
  widget.size array
  dup .type t_main put
  dup .font font1 put
  dup .ed.font font1 put
  dup .color.fg boot.text.normal put
  
} def


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
% Initialize main window.
%
% ( window ) ==> ( )
%
/main.init {
  pop
} def


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
% Draw main window.
%
% ( window ) ==> ( )
%
/main.show {
  window.push

  /menu.shift 0 def
  /menu.visible.entries menu.texts length menu.max.entries min def

  % get index of default entry
  /menu.entry 0 def
  0 1 menu.texts length 1 sub {
    dup menu.texts exch get menu.dentry eq { /menu.entry exch def exit } { pop } ifelse
  } for

  menu.entry menu.visible.entries sub 0 ge {
    /menu.shift menu.entry menu.texts length menu.visible.entries sub min def
  } if

  -1 -1 0 fillmode

  frame2.pos moveto prog_frame_color dup prog_frame_color2 frame2.size drawborder3

  menu.visible.entries menu.texts length lt menu.scrollbar and {
   /menu.bar.width frame1.size pop frame4.size pop sub def

    -1 settransparentcolor

    frame4.pos moveto black dup frame4.size drawborder
    frame4.pos moveto
    ms.up ms.size image
    frame4.pos moveto frame4.size exch pop 0 exch ms.size exch pop 0 add sub rmoveto
    ms.down ms.size image

    /menu.sb.x frame4.pos pop 1 add def
    /menu.sb.y frame4.pos exch pop 22 add def
    /menu.sb.width frame4.size pop 2 sub def
    /menu.sb.height frame4.size exch pop 22 2 mul sub def

    menu.sb.x menu.sb.y 1 sub moveto
    menu.sb.x menu.sb.width add menu.sb.y 1 sub lineto

    menu.sb.x menu.sb.y menu.sb.height add moveto
    menu.sb.x menu.sb.width add menu.sb.y menu.sb.height add lineto
  } if

  boot.text.options setcolor

  window.current .font get setfont

  frame3.pos moveto
  "opcik:" show

  /boot.ed.width frame2.size pop 10 sub def
  /boot.ed.height fontsize exch pop 2 add def

  /boot.ed [
    frame2.pos exch 5 add exch 5 add
    over over moveto boot.ed.width boot.ed.height savescreen
    boot.buf
    boot.buf.size
    0
    0
    0
  ] def

  window.current .ed boot.ed put

  redrawmenu
  menu.entry true MenuSelect

  % find default splash mode
  0 1 splash.options length 1 sub {
    splash.options over get menu.args menu.entry get exch strstr {
      /splash.default exch def
    } {
      pop
    } ifelse
  } for

  fkeys.init

  "main" help.setcontext

} def


% ( ) ==> ( )
/show_video_menu {
  window.xmenu
  dup .xmenu xmenu.video put
  dup window.init
      window.show
} def


% ( ) ==> ( )
/show_splash_menu {
  window.xmenu
  dup .xmenu xmenu.splash put
  dup window.init
      window.show
} def


% ( ) ==> ( )
/show_keytable_menu {
  window.xmenu
  dup .xmenu xmenu.keytable put
  dup window.init
      window.show
} def


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
% Handle keyboard input.
%
% ( key_in ) ==> ( key_out )
%
/main.input {
  dup 0 eq { return } if 

  dup keyF1 eq {
    help.context "opt" eq {
      findbootoption
      help.mapcontext
      dup help.findpage
      "" eq { pop } { help.setcontext } ifelse
    } if
    show_help
    pop 0
  } if

  dup keyF2 eq syslinux and {
    "videomode" help.setcontext
    show_video_menu
    pop 0
  } if

  dup keyF2 eq lilo grub or and
  over keyF4 eq syslinux and or
  {
    "startup" help.setcontext
    show_splash_menu
    pop 0
  } if

  dup keyF3 eq syslinux and {
    do_driverupdate _undef eq {
      /do_driverupdate 1 def
      1 updatedisk
      black setcolor
      currentfont font1 setfont
      update.pos moveto currentpoint
      prog_frame_color dup prog_frame_color2
      update.text strsize 6 add exch 16 add exch
%      over over dud_color setcolor fillrect
      drawborder3
      moveto 8 3 rmoveto update.text white setcolor show
      setfont
    }
    {
      /do_driverupdate _undef def
      0 updatedisk
      update.pos moveto currentpoint
      update.text strsize 7 add exch 17 add exch
      image
    } ifelse

    "driverupdate" help.setcontext
    pop 0
  } if

  dup keyF9 eq {
    "keytable" help.setcontext
    show_keytable_menu
    pop 0
  } if

  dup keyF10 eq {
    power_off
    pop 0
  } if

  dup keyEsc eq { exit_popup pop 0 } if

  dup keyEnter eq {
    /window.action actStart def
    pop 0
  } if

  dup keyUp eq {
    menu.entry 0 gt {
      menu.entry false MenuSelect
      menu.entry menu.shift eq {
        /menu.shift menu.shift 1 sub def redrawmenu
      } if
      /menu.entry menu.entry 1 sub def
      menu.entry true MenuSelect
    } if
    pop 0
  } if

  dup keyDown eq {
    menu.entry menu.texts length 1 sub lt {
      menu.entry false MenuSelect
      menu.visible.entries menu.entry menu.shift sub sub 1 eq {
        /menu.shift menu.shift 1 add def redrawmenu
      } if
      /menu.entry menu.entry 1 add def
      menu.entry true MenuSelect
    } if
    pop 0
  } if

  dup keyPgUp eq {
    menu.entry 0 gt {
      menu.entry false MenuSelect
      /menu.entry 0 def
      menu.shift 0 ne {
        /menu.shift 0 def redrawmenu
      } if
      menu.entry true MenuSelect
    } if
    pop 0
  } if

  dup keyPgDown eq {
    menu.entry menu.texts length 1 sub lt {
      menu.entry false MenuSelect
      /menu.entry menu.texts length 1 sub def
      menu.texts length menu.visible.entries sub dup menu.shift ne {
        /menu.shift exch def redrawmenu
      } {
        pop
      } ifelse
      menu.entry true MenuSelect
    } if
    pop 0
  } if

  dup 0 ne {
    "opt" help.setcontext
  } if

} def


